//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  White
#property indicator_color2  Aqua
#property indicator_color3  Yellow

extern int  NmrLength = 20;
extern bool WrongWay  = false;

double extmapbuffer1[];
double extmapbuffer2[];
double extmapbuffer3[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
  SetIndexBuffer (0, extmapbuffer1);
  SetIndexBuffer (1, extmapbuffer2);
  SetIndexBuffer (2, extmapbuffer3);
  return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
  int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-NmrLength-1);

   //
   //
   //
   //
   //

   for(int i = limit; i >= 0; i--)
   {
      double sum=0,sum2=0,x=0,r=0;
      for (int k=0; k<NmrLength; k++)
      {
         if (k>0)
         {
            sum  += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000);
            sum2 += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000)*(MathSqrt(k+1)-MathSqrt(k));
         }
         else r += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000);
              x += (MathLog(Close[i])*100000 - MathLog(Close[i+k+1])*100000)/MathSqrt(k+1);
      }
      r += sum2; x /= (NmrLength*1.0);          
      double ratio = 1; if (sum!=0) ratio = MathRound(sum2)/MathRound(sum);
      if (WrongWay)
         {
            extmapbuffer1[i] =  ratio*x;
            extmapbuffer2[i] =  ratio*ratio*r;
         }
      else
         {
            extmapbuffer1[i] =  extmapbuffer1[i+1]+ratio*(x-extmapbuffer1[i+1]);
            extmapbuffer2[i] =  extmapbuffer2[i+1]+ratio*(r*ratio - extmapbuffer2[i+1]);
         }         
      extmapbuffer3[i] = -extmapbuffer2[i];
   }
   return(0);
}